---
title: WeakRef.prototype.deref()
slug: Web/JavaScript/Reference/Global_Objects/WeakRef/deref
tags:
  - JavaScript
  - Method
  - Prototype
  - Reference
  - WeakRef
---
<div>{{JSRef}}</div>

<p>The <code>deref</code> method returns the {{jsxref("WeakRef")}} instance's target object, or <code>undefined</code> if the target object has been garbage-collected.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><code><var>obj</var> = <var>ref</var>.deref();</code>
</pre>

<h3 id="Return_value">Return value</h3>

<p>The target object of the WeakRef, or <code>undefined</code> if the object has been garbage-collected.</p>

<h2 id="Notes">Notes</h2>

<p>See the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/WeakRef#Notes_on_WeakRefs">Notes on WeakRefs</a> section of the {{jsxref("WeakRef")}} page for some important notes.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_deref">Using deref</h3>

<p>See the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/WeakRef#Examples">Examples</a> section of the {{jsxref("WeakRef")}} page for the complete example.</p>

<pre class="brush: js notranslate">const tick = () =&gt; {
  // Get the element from the weak reference, if it still exists
  const element = this.ref.deref();
  if (element) {
    element.textContent = ++this.count;
  } else {
    // The element doesn't exist anymore
    console.log("The element is gone.");
    this.stop();
    this.ref = null;
  }
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WeakRefs', '#sec-weak-ref.prototype.deref', 'WeakRef.prototype.deref()')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.WeakRef.deref")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("WeakRef")}}</li>
</ul>
